scala

# Array

#### object Array extends FallbackArrayBuilding with Serializable

Utility methods for operating on arrays.

Source
  Array.scala
Version

  1.0

Linear Supertypes
Serializable, Serializable, FallbackArrayBuilding, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Array
2. Serializable
3. Serializable
4. FallbackArrayBuilding
5. AnyRef
6. Any

Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### def apply(x: Unit, xs: Unit*): Array[Unit]

   Creates an array of `Unit` objects

7. #### def apply(x: Double, xs: Double*): Array[Double]

   Creates an array of `Double` objects

8. #### def apply(x: Float, xs: Float*): Array[Float]

   Creates an array of `Float` objects

9. #### def apply(x: Long, xs: Long*): Array[Long]

   Creates an array of `Long` objects

10. #### def apply(x: Int, xs: Int*): Array[Int]

    Creates an array of `Int` objects

11. #### def apply(x: Char, xs: Char*): Array[Char]

    Creates an array of `Char` objects

12. #### def apply(x: Short, xs: Short*): Array[Short]

    Creates an array of `Short` objects

13. #### def apply(x: Byte, xs: Byte*): Array[Byte]

    Creates an array of `Byte` objects

14. #### def apply(x: Boolean, xs: Boolean*): Array[Boolean]

    Creates an array of `Boolean` objects

15. #### def apply[T](xs: T*)(implicit arg0: ClassManifest[T]): Array[T]

    Creates an array with given elements.

    Creates an array with given elements.

    xs

      the elements to put in the array

    returns

      an array containing all elements from xs.

16. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

17. #### implicit def canBuildFrom[T](implicit m: ClassManifest[T]): CanBuildFrom[Array[_], T, Array[T]]

18. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

19. #### def concat[T](xss: Array[T]*)(implicit arg0: ClassManifest[T]): Array[T]

    Concatenates all arrays into a single array.

    Concatenates all arrays into a single array.

    xss

      the given arrays

    returns

      the array created from concatenating `xss`

20. #### def copy(src: AnyRef, srcPos: Int, dest: AnyRef, destPos: Int, length: Int): Unit

    Copy one array to another.

    Copy one array to another. Equivalent to Java's `System.arraycopy(src, srcPos, dest, destPos, length)`, except that this also works for polymorphic and boxed arrays.

    Note that the passed-in `dest` array will be modified by this call.

    src

      the source array.

    srcPos

      starting position in the source array.

    dest

      destination array.

    destPos

      starting position in the destination array.

    length

      the number of array elements to be copied.

    See also

      `java.lang.System#arraycopy`

21. #### def empty[T](implicit arg0: ClassManifest[T]): Array[T]

    Returns an array of length 0

22. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

24. #### implicit def fallbackCanBuildFrom[T](implicit m: DummyImplicit): CanBuildFrom[Array[_], T, ArraySeq[T]]

    A builder factory that generates a generic array.

    A builder factory that generates a generic array. Called instead of Array.newBuilder if the element type of an array does not have a class manifest. Note that fallbackBuilder factory needs an implicit parameter (otherwise it would not be dominated in implicit search by Array.canBuildFrom). We make sure that that implicit search is always successful.

    Definition Classes
      FallbackArrayBuilding

25. #### def fill[T](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(elem: ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[Array[T]]]]]

    Returns a five-dimensional array that contains the results of some element computation a number of times.

    Returns a five-dimensional array that contains the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    elem

      the element computation

26. #### def fill[T](n1: Int, n2: Int, n3: Int, n4: Int)(elem: ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[T]]]]

    Returns a four-dimensional array that contains the results of some element computation a number of times.

    Returns a four-dimensional array that contains the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    elem

      the element computation

27. #### def fill[T](n1: Int, n2: Int, n3: Int)(elem: ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[Array[T]]]

    Returns a three-dimensional array that contains the results of some element computation a number of times.

    Returns a three-dimensional array that contains the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    elem

      the element computation

28. #### def fill[T](n1: Int, n2: Int)(elem: ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[T]]

    Returns a two-dimensional array that contains the results of some element computation a number of times.

    Returns a two-dimensional array that contains the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    elem

      the element computation

29. #### def fill[T](n: Int)(elem: ⇒ T)(implicit arg0: ClassManifest[T]): Array[T]

    Returns an array that contains the results of some element computation a number of times.

    Returns an array that contains the results of some element computation a number of times.

    Note that this means that `elem` is computed a total of n times:

        scala> Array.fill(3){ java.lang.Math.random }
        res3: Array[Double] = Array(0.365461167592537, 1.550395944913685E-4, 0.7907242137333306)

    n

      the number of elements desired

    elem

      the element computation

    returns

      an Array of size n, where each element contains the result of computing `elem`.

30. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

31. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

32. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

33. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

34. #### def iterate[T](start: T, len: Int)(f: (T) ⇒ T)(implicit arg0: ClassManifest[T]): Array[T]

    Returns an array containing repeated applications of a function to a start value.

    Returns an array containing repeated applications of a function to a start value.

    start

      the start value of the array

    len

      the number of elements returned by the array

    f

      the function that is repeatedly applied

    returns

      the array returning `len` values in the sequence `start, f(start), f(f(start)), ...`

35. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

36. #### def newBuilder[T](implicit m: ClassManifest[T]): ArrayBuilder[T]

    Returns a new ArrayBuilder.

37. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

38. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### def ofDim[T](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[Array[T]]]]]

    Creates a 5-dimensional array

40. #### def ofDim[T](n1: Int, n2: Int, n3: Int, n4: Int)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[T]]]]

    Creates a 4-dimensional array

41. #### def ofDim[T](n1: Int, n2: Int, n3: Int)(implicit arg0: ClassManifest[T]): Array[Array[Array[T]]]

    Creates a 3-dimensional array

42. #### def ofDim[T](n1: Int, n2: Int)(implicit arg0: ClassManifest[T]): Array[Array[T]]

    Creates a 2-dimensional array

43. #### def ofDim[T](n1: Int)(implicit arg0: ClassManifest[T]): Array[T]

    Creates array with given dimensions

44. #### def range(start: Int, end: Int, step: Int): Array[Int]

    Returns an array containing equally spaced values in some integer interval.

    Returns an array containing equally spaced values in some integer interval.

    start

      the start value of the array

    end

      the end value of the array, exclusive (in other words, this is the first value not returned)

    step

      the increment value of the array (may not be zero)

    returns

      the array with values in `start, start + step, ...` up to, but excluding `end`

45. #### def range(start: Int, end: Int): Array[Int]

    Returns an array containing a sequence of increasing integers in a range.

    Returns an array containing a sequence of increasing integers in a range.

    end

      the end value of the array, exclusive (in other words, this is the first value not returned)

    returns

      the array with values in range `start, start + 1, ..., end - 1` up to, but excluding, `end`.

46. #### def readResolve(): AnyRef

    Attributes
      protected

47. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

48. #### def tabulate[T](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(f: (Int, Int, Int, Int, Int) ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[Array[T]]]]]

    Returns a five-dimensional array containing values of a given function over ranges of integer values starting from 0.

    Returns a five-dimensional array containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    f

      The function computing element values

49. #### def tabulate[T](n1: Int, n2: Int, n3: Int, n4: Int)(f: (Int, Int, Int, Int) ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[T]]]]

    Returns a four-dimensional array containing values of a given function over ranges of integer values starting from 0.

    Returns a four-dimensional array containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    f

      The function computing element values

50. #### def tabulate[T](n1: Int, n2: Int, n3: Int)(f: (Int, Int, Int) ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[Array[T]]]

    Returns a three-dimensional array containing values of a given function over ranges of integer values starting from 0.

    Returns a three-dimensional array containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    f

      The function computing element values

51. #### def tabulate[T](n1: Int, n2: Int)(f: (Int, Int) ⇒ T)(implicit arg0: ClassManifest[T]): Array[Array[T]]

    Returns a two-dimensional array containing values of a given function over ranges of integer values starting from 0.

    Returns a two-dimensional array containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    f

      The function computing element values

52. #### def tabulate[T](n: Int)(f: (Int) ⇒ T)(implicit arg0: ClassManifest[T]): Array[T]

    Returns an array containing values of a given function over a range of integer values starting from 0.

    Returns an array containing values of a given function over a range of integer values starting from 0.

    n

      The number of elements in the array

    f

      The function computing element values

    returns

      A traversable consisting of elements `f(0),f(1), ..., f(n - 1)`

53. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

54. #### def unapplySeq[T](x: Array[T]): Option[IndexedSeq[T]]

    Called in a pattern match like `{ case Array(x,y,z) => println('3 elements')}`.

    Called in a pattern match like `{ case Array(x,y,z) => println('3 elements')}`.

    x

      the selector value

    returns

      sequence wrapped in a Some, if x is a Seq, otherwise `None`

55. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

56. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

57. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Deprecated Value Members

1. #### def fromFunction[T](f: (Int, Int, Int, Int, Int) ⇒ T)(n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[Array[T]]]]]

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2, 0..n3, 0..n4, 0..n5)`

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2, 0..n3, 0..n4, 0..n5)`

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `Array.tabulate' instead`

2. #### def fromFunction[T](f: (Int, Int, Int, Int) ⇒ T)(n1: Int, n2: Int, n3: Int, n4: Int)(implicit arg0: ClassManifest[T]): Array[Array[Array[Array[T]]]]

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2, 0..n3, 0..n4)`

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2, 0..n3, 0..n4)`

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `Array.tabulate' instead`

3. #### def fromFunction[T](f: (Int, Int, Int) ⇒ T)(n1: Int, n2: Int, n3: Int)(implicit arg0: ClassManifest[T]): Array[Array[Array[T]]]

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2, 0..n3)`

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2, 0..n3)`

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `Array.tabulate' instead`

4. #### def fromFunction[T](f: (Int, Int) ⇒ T)(n1: Int, n2: Int)(implicit arg0: ClassManifest[T]): Array[Array[T]]

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2)`

   Creates an array containing the values of a given function `f` over given range `[0..n1, 0..n2)`

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `Array.tabulate' instead`

5. #### def fromFunction[T](f: (Int) ⇒ T)(n: Int)(implicit arg0: ClassManifest[T]): Array[T]

   Creates an array containing the values of a given function `f` over given range `[0..n)`

   Creates an array containing the values of a given function `f` over given range `[0..n)`

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `Array.tabulate' instead`

6. #### def make[T](n: Int, elem: T)(implicit arg0: ClassManifest[T]): Array[T]

   Creates an array containing several copies of an element.

   Creates an array containing several copies of an element.

   n

     the length of the resulting array

   elem

     the element composing the resulting array

   returns

     an array composed of n elements all equal to elem

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `Array.fill' instead`

### Inherited from Serializable

### Inherited from FallbackArrayBuilding

### Inherited from AnyRef

### Inherited from Any